'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isObject = require('./isObject');

var _isObject2 = _interopRequireDefault(_isObject);

var _isStyleObject = require('./isStyleObject');

var _isStyleObject2 = _interopRequireDefault(_isStyleObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Recursively check for objects that are style rules.
 */
var getStyleObjects = function getStyleObjects(styles) {
  var keys = Object.keys(styles);
  return keys.reduce(function (rules, key) {
    var possibleRule = styles[key];
    if ((0, _isObject2.default)(possibleRule)) {
      if ((0, _isStyleObject2.default)(possibleRule)) {
        rules.push(possibleRule);
      } else {
        rules = rules.concat(getStyleObjects(possibleRule));
      }
    }
    return rules;
  }, []);
};

exports.default = getStyleObjects;