"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pickProps = pickProps;
exports.omitProps = omitProps;
function filterProps(obj, propKeys) {
  var excluded = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  var filtered = {};
  for (var prop in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, prop)) {
      var isMatch = propKeys.indexOf(prop) > -1;
      if (excluded && isMatch) {
        continue;
      } else if (!excluded && !isMatch) {
        continue;
      }

      filtered[prop] = obj[prop];
    }
  }

  return filtered;
}

function pickProps(obj, propKeys) {
  return filterProps(obj, propKeys);
}

function omitProps(obj, propKeys) {
  return filterProps(obj, propKeys, true);
}